import requests, string, random
import ipywidgets as widgets
from IPython.display import display
import json
from pathlib import Path


def ask(collection):
    
    URL = 'https://www.student.hs-mittweida.de/~fhechler/cgi-bin/ask.cgi'
    if not requests.get("https://www.student.hs-mittweida.de/~fhechler/cgi-bin/ask.cgi").status_code == 200:
            raise Exception("Dienst nicht erreichbar.")
            
 
    if requests.post(URL, data = {"collection": collection}).text.replace("\n","") == "nocollection":
        raise Exception(f"Sammlung {collection} nicht vorhanden.")
       
    
    
    key_file = Path("key.json")
    if not key_file.is_file():
        file = open("./key.json", "w+")
        json.dump({"key": ''.join(random.choice(string.ascii_letters + string.digits) for i in range(32))}, file)
        file.close()
        print("Key wurde in Datei key.json generiert.")

    
    file = open("key.json", "r")
    key = json.load(file)
    
    request = requests.post(URL, data = {"key": key["key"], "action": "read", "collection": collection})
    print(request.text)
    
    
    layout_hidden = widgets.Layout(visibility = 'hidden')  
     

    input_message = widgets.Textarea(value='', placeholder='Hier Nachricht eingeben', disabled=False, layout = widgets.Layout(width = "50%", height = "400px"))

    button_send = widgets.Button(description="Absenden", button_style="success")
    

    ask_form = widgets.GridBox([input_message, button_send], layout=widgets.Layout(width = "auto", height = "auto"))

    display(ask_form)

    
    
    def on_button_send(b):

        if not requests.get("https://www.student.hs-mittweida.de/~fhechler/cgi-bin/ask.cgi").status_code == 200:
            print("Fehler: Dienst nicht erreichbar.")
        else:
            status = requests.post(URL, data = {"key": key["key"], "action": "write", "collection": collection, "message": input_message.value.replace("ü","ue").replace("ß","ss").replace("ä","ae").replace("ö","oe").replace("Ü","Ue").replace("Ö","Oe").replace("Ä","Ae").encode("ascii", "replace")}).text.replace("\n","")
            if status == "nomessage":
                print("\033[1m\033[31mFehler: Nachricht darf nicht leer sein.\033[0m")
            elif status == "success":
                ask_form.layout = layout_hidden
                print("\033[1m\033[32mNachricht wurde gesendet. Zelle erneut ausführen, um zu aktualisieren.\033[0m")
            else:
                print(f"\033[1m\033[31mUnbekannter Fehler (Wahrscheinlich Kodierung, gibt es ein 'exotisches' Zeichen im Text?  {status}\033[0m)")
                    
    button_send.on_click(on_button_send)