import requests
import ipywidgets as widgets
from IPython.display import display, HTML

class Feedback:
    
    COLLECTIONS = ["P12_Extra"]
    URL = 'https://www.student.hs-mittweida.de/~fhechler/cgi-bin/feedback.cgi'
    
    def __init__(self, collection):
        
        self.collection = collection
        
        if not requests.get(type(self).URL).status_code == 200:
            raise Exception("Feedbackdienst nicht erreichbar.")

        status = self.execute("", "")
        
        if status == "nocollection":
            raise Exception(f"Feedbackbereich {collection} existieren nicht.")
      
        
    
    def load(self, task):
        
        if not requests.get(type(self).URL).status_code == 200:
            raise Exception("Feedbackdienst nicht erreichbar.")

        status = self.execute(task, "")
        
        if status == "inactive":
            raise Exception("Diese Feedbackfunktion ist nicht mehr aktiv.")
        if status == "notask":
            raise Exception(f"Aufgabe {task} existieren nicht.")
        if not status == "novalue":
            raise Exception("Unbekannter Fehler.")
        
        layout_hidden = widgets.Layout(visibility = 'hidden')  
        
        def on_button_send(b):
            
            if not requests.get(type(self).URL).status_code == 200:
                print("Fehler: Feedbackdienst nicht erreichbar.")
            else:
                status = self.execute(task, input_message.value)
                if status == "novalue":
                    print("Fehler: Eingabe darf nicht leer sein.")
                elif status == "success":
                    #input_task.layout = layout_hidden
                    #input_message.layout = layout_hidden
                    #button_send.layout = layout_hidden
                    feedback_form.layout = layout_hidden
                    print("Vielen Dank! Das Feedback wurde erfolgreich gesendet.")
            
            
            
          
        #input_task = widgets.Text(value = task, disabled=True)
        print(f"Feedback zu: {task}")
        input_message = widgets.Textarea(value='', placeholder='Hier Feedback eingeben', disabled=False, layout = widgets.Layout(width = "50%", height = "400px"))
        
        button_send = widgets.Button(description="Absenden",  button_style="success")
        button_send.on_click(on_button_send)

        feedback_form = widgets.GridBox([input_message, button_send], layout=widgets.Layout(width = "auto", height = "auto"))
        
        display(feedback_form)

    def execute(self, task, message):
        return requests.post(type(self).URL, data = {'collection': self.collection, 'task': task, 'message': message.replace("ü","ue").replace("ß","ss").replace("ä","ae").replace("ö","oe").replace("Ü","Ue").replace("Ö","Oe").replace("Ä","Ae").encode("ascii", "replace")}).text.replace("\n","")

