from IPython.display import display, HTML, Video
import requests    

class JnVideo:

    
    def __init__(self, collection, width):
        self.collection = collection
        self.width = width
        display(HTML("<style>.widget-textarea textarea { font-size: 120%; padding: 20px; line-height: 130% }</style>"))
        
        if not requests.get(f"https://www.student.hs-mittweida.de/~fhechler/videos/{self.collection}/").status_code == 403:
            raise Exception(f"Videosammlung {collection} nicht gefunden.")
        

      

    
    def load(self, videoname):

        videoUrl=f"https://www.student.hs-mittweida.de/~fhechler/videos/{self.collection}/{videoname}.mp4"
        
        if not requests.get(videoUrl).status_code == 200:
            raise Exception(f"Video {videoname} nicht gefunden.")
        
        display(Video(data=videoUrl, url=None, filename=None, embed=False, mimetype=None, width=self.width, height=int((self.width/16)*9), html_attributes='controls'))

