import ipywidgets as widgets
from IPython.display import display
from hsmwfh.jnvideo import JnVideo
import json

def settings():
    OPTIONS_DESIGN = ["Unverändert", "Optimiert", "Präsentation"]
    OPTIONS_MONITOR = ["Unverändert", "Komplette Breite"]
    OPTIONS_DESIGN_DESC = ["Original von Jupyter Notebook, keine Anpassungen", "Angepasstes Design, größere Schrift, verbesserte Lesbarkeit", "Sehr große Schrift für Präsentation, wird im Tutorium verwendet"]
    OPTIONS_MONITOR_DESC = ["Original von Jupyter Notebook, keine Anpassungen", "Randlos, nutzt Komplette Breite für Inhalt"]
    
    layout_hidden  = widgets.Layout(visibility = 'hidden')
    
    select_design = widgets.ToggleButtons(
        options = OPTIONS_DESIGN,
        value = OPTIONS_DESIGN[getSettings()["design"]],
        description = 'Design:',
        disabled = False,
        tooltips = OPTIONS_DESIGN_DESC
    )

    select_monitor = widgets.ToggleButtons(
        options = OPTIONS_MONITOR,
        value = OPTIONS_MONITOR[int(getSettings()["monitor"])],
        description = "Breite:",
        disabled = False,
        tooltips = OPTIONS_MONITOR_DESC
    )


    select_player_width = widgets.SelectionSlider(
        options = [360, 480, 640, 800, 1024, 1200, 1400, 1600, 1800],
        value = getSettings()["player_width"],
        disabled = False,
        continuous_update = True,
        orientation = 'horizontal',
        readout = False
    )

    def f(a):
        print(f"Playerbreite: {a} Pixel")


    out = widgets.interactive_output(f, {"a": select_player_width})
    widgets.HBox([out])


    design_settings = widgets.GridBox([select_design,select_monitor], layout=widgets.Layout(grid_template_columns="repeat(2, 300px)"))
    player_settings = widgets.GridBox([out, select_player_width], layout=widgets.Layout(grid_template_columns="repeat(1, 600px)"))

    tab_contents = ["Design", "Videos"]
    tab = widgets.Tab()
    tab.children = [design_settings, player_settings]
    for i in range(len(tab_contents)):
        tab.set_title(i, tab_contents[i])

    button_okay = widgets.Button(description="Speichern",  button_style="success")

    def on_button_clicked(b):
        file = open("./settings.json", "w+")
        json.dump({"player_width": select_player_width.value, "monitor": select_monitor.value == "Komplette Breite", "design": OPTIONS_DESIGN.index(select_design.value)}, file)
        file.close()
        tab.layout = layout_hidden
        button_okay.layout = layout_hidden
        print("Einstellungen gespeichert!")
    button_okay.on_click(on_button_clicked)

    display(tab, button_okay)
    
    
def getSettings():
    file = open('./settings.json', 'r')
    output = json.load(file)
    file.close()
    return output
    
